#include <PA9.h>
#include <stdio.h> //<-- For sscanf();
#include <string.h> //<-- For strcat();

int main(void){

PA_Init(); 
PA_InitVBL(); 
PA_InitSound();

PA_Init16bitBg(1, 3); // JPEG HEAVEN!
PA_Init16bitBg(0, 3); 
PA_InitText(1, 0); // Text on top screen
PA_InitText(0, 0);

PA_SetBrightness(1,-32); // For fading
PA_SetBrightness(0,-32);

//GBFS!
u8 NumberOfFiles = PA_InitGBFS(); //Init GBFS and get number of files in the archive!

//Main INIT
u8 NumberOfMods=0, MaxOnscreen=10, CursorPos=0, Offset=0, PadCounter=0;
s16 MyMods[100];
s8 a=0; //Global iterator
char TextBuffer[62];
bool NeedList=false, ShowDebug=false;

//Global Skinvars (sscan needs int)
int PlaylistX=0, PlaylistY=0, PlaylistX2=32, PlaylistY2=24;
int FontR=31, FontG=0, FontB=0;


if (NumberOfFiles==0){
   PA_OutputText(0,2,2,"NO FILE(s) ----!");  //Flashes a message when there are no files in GBFS

} else {
  
  // --- SKINCODE! ---
  	
    s8 filebuffer = PA_GetGBFSFile(0, "Skin_Default_TOP", "");            // Checks for the default top screen skin 
  	if (filebuffer > -1) PA_LoadJpeg(1, PA_GBFSfile[filebuffer].File);    // I invoked no error here, as it works without a skin
  
    filebuffer = PA_GetGBFSFile(0, "Skin_Default_BTM", "");               // Same for bottom screen.
  	if (filebuffer > -1) PA_LoadJpeg(0, PA_GBFSfile[filebuffer].File);  
  	
  	filebuffer = PA_GetGBFSFile(0, "Skin_Default_CFG", "");                // Fetch skin config
  	if (filebuffer > -1){
        
       /* --- These stop working when they hit newline! ---
       sscanf(PA_GBFSfile[filebuffer].File, "PlaylistPos(%d,%d,%d,%d);", &PlaylistX, &PlaylistY, &PlaylistW, &PlaylistH);
       sscanf(PA_GBFSfile[filebuffer].File, "FontRGB(%d,%d,%d);", &FontR, &FontG, &FontB);
       */
       
       // UGLY fix of the above problem, basically merged the two commands with a forced newline between... 
       // Not good, but it'll hold untill i can make some new parsecode. :D
       sscanf(PA_GBFSfile[filebuffer].File, "PlaylistPos(%d,%d,%d,%d);\nFontRGB(%d,%d,%d);", &PlaylistX, &PlaylistY, &PlaylistX2, &PlaylistY2, &FontR, &FontG, &FontB);
       
       MaxOnscreen=(PlaylistY2-PlaylistY)-2; // Calculate max files shown at the time with current skin!  (-2 is the gap between the last file and the positionbar at the very bottom) 
       PA_SetTextCol(0, FontR, FontG, FontB); 
    }

  NumberOfMods=PA_GBFSSearchExt(MyMods,"mod"); //Populate MyMods
  
  if (NumberOfMods>MaxOnscreen) NeedList=true; // Checks if the ammount of files is bigger than the playlist size!
  

  //FADEIN
  for(a=-32; a<0; a++){ // Fading in!(todo: improve! >:|)
	PA_SetBrightness(1,a);
    PA_SetBrightness(0,a);
    PA_WaitForVBL();
    PA_WaitForVBL();
    PA_WaitForVBL();
  } 
    
  // -- JINGLE! ---
  filebuffer = PA_GetGBFSFile(0, "jingle", "raw");
  if (filebuffer > -1) PA_PlayGBFSSimpleSound(0, filebuffer); 
  
}

while(1) {    // --- MAIN LOOP! ---

    if (Pad.Held.Up || Pad.Newpress.Up) { // UP [^]
       
       PadCounter=PadCounter+1;
       if (PadCounter>=10 || Pad.Newpress.Up){ 
           
           PadCounter=0;
           
           if (CursorPos==0 && Offset!= 0) Offset--; // MAIN LIST CODE!
    		
           if(CursorPos>0){ 
            PA_OutputText(0,PlaylistX, PlaylistY + CursorPos,"  "); 
            CursorPos--;
           }  
       }
    }
        
    if (Pad.Held.Down || Pad.Newpress.Down){ // DOWN [V]
       
       PadCounter=PadCounter+1;
       if (PadCounter>=10 || Pad.Newpress.Down){ 
           
           PadCounter=0;
          
           PA_OutputText(0,PlaylistX, PlaylistY + CursorPos,"  "); // MAIN LIST CODE!
           
           if (NeedList){
    		if (CursorPos==MaxOnscreen-1 && Offset+MaxOnscreen<NumberOfMods) Offset++;
            if (CursorPos<MaxOnscreen-1) CursorPos++;
           } else {
            if (CursorPos!=NumberOfMods-1) CursorPos++;
           }    
       }           
    }
    
    if (Pad.Released.Up) PadCounter=0;
    if (Pad.Released.Down) PadCounter=0;
    
    for(a=Offset; a<Offset+(MaxOnscreen); a++){ //UPDATE PLAYLIST!
        
        if (NeedList==false && a==NumberOfMods) break;  //Break on needlist=false!
        
        strcat(TextBuffer, PA_GBFSfile[MyMods[a]].Name);   
        strcat(TextBuffer, "                                "); //32 spaces for clearing up text!
        PA_BoxTextNoWrap(0, PlaylistX+2, PlaylistY + (a-Offset), PlaylistX2-1, 3, TextBuffer, PlaylistX2-1);
        TextBuffer[0]='\0';
    }
	
    PA_BoxTextNoWrap(0, PlaylistX+2, PlaylistY2-1, PlaylistX2-1, 3, "---------------------------", PlaylistX2-1);



    if (Pad.Newpress.A){ // [A] PLAY MOD!
        PA_StopMod();  
        PA_PlayGBFSMod(MyMods[CursorPos+Offset]);
    }             
    
    if (Pad.Newpress.Y){ // [Y] STOP MOD!
       PA_StopMod(); 
    } 
	
	
    if (Pad.Held.L && Pad.Held.R && Pad.Newpress.Select){ // [L]+[R]+SELECT = DEBUGMODE!
       if (ShowDebug){
        ShowDebug=false;
        PA_ShowBg(1,3);
        PA_HideBg(1,0);
       } else {
        ShowDebug=true;
        PA_HideBg(1,3);
        PA_ShowBg(1,0);
       } 
    }
 
    PA_OutputText(0, PlaylistX, PlaylistY + CursorPos, ">"); //PRINT CURSOR!
    PA_OutputText(0, PlaylistX, PlaylistY2-1, "- %d/%d -", CursorPos+Offset+1, NumberOfMods); // PRINT FILEPOS!
    
    if (ShowDebug) { // SHOWS DEBUG! :P
       PA_OutputText(1, 1, 1, "PAMOD v1.1 by Kleevah" );
       PA_OutputText(1, 1, 3, "--- DEBUG: ----"); 
       PA_OutputText(1, 1, 4, "Playlist X/Y  : %d/%d ", PlaylistX, PlaylistY); 
       PA_OutputText(1, 1, 5, "Playlist X2/Y2: %d/%d ", PlaylistX2, PlaylistY2);
       PA_OutputText(1, 1, 6, "FontRGB: %d/%d/%d ", FontR, FontG, FontB);
       PA_OutputText(1, 1, 7, "NumberOfFiles: %d ", NumberOfFiles);
       PA_OutputText(1, 1, 8, "NumberOfMods: %d ", NumberOfMods);
       PA_OutputText(1, 1, 9, "NeedList: %d ", NeedList);
       PA_OutputText(1, 1, 10, "MaxOnscreen: %d ", MaxOnscreen);
       PA_OutputText(1, 1, 11, "CursorPos: %d  ", CursorPos);
       PA_OutputText(1, 1, 12, "Offset: %d  ", Offset);
       PA_OutputText(1, 1, 13, "CursorPos+Offset: %d  ", CursorPos+Offset);
       PA_OutputText(1, 1, 14, "PadCounter: %d ", PadCounter);
    }     

    PA_WaitForVBL();
}
 return 0;
}

